/* 
 *  print_fcntl.c -	Decode fcntl() requests
 *
 *  <john@ratbert.cc.iastate.edu> John Hascall
 *  Sat Mar  2 02:04:03 CST 1996
 *
 */
#include "trace.h"
#include "sysname.h"
#include <sys/fcntl.h>


extern FILE *	outfp;
extern int	max_string;

int printargs_fcntl (
	long	sysCallno,
	long *	sysArgs,
	int	sysNumargs,
	char *	sysFormat
) {
	fprintf(outfp, "fcntl (%d, ", sysArgs[0]);
	switch ((int)sysArgs[1]) {
	    case F_DUPFD:	fprintf(outfp, "F_DUPFD, ");	break;
	    case F_GETFD:	fprintf(outfp, "F_GETFD, ");	break;
	    case F_SETFD:	fprintf(outfp, "F_SETFD, ");	break;
	    case F_GETFL:	fprintf(outfp, "F_GETFL, ");	break;
	    case F_SETFL:	fprintf(outfp, "F_SETFL, ");	break;
	    case F_GETLK:	fprintf(outfp, "F_GETLK, ");	break;
	    case F_SETLK:	fprintf(outfp, "F_SETLK, ");	break;
	    case F_SETLKW:	fprintf(outfp, "F_SETLKW, ");	break;
	    default:		fprintf(outfp, "?F_#%u, ", (int)sysArgs[1]);
	}
	fprintf(outfp, "%d) = ", sysArgs[2]);
	return (1);
}

int printret_fcntl (
	long	sysCallno,
	long	sysReturn,
	int	sysErrno
) {
	if (sysReturn == -1) {
		fprintf(outfp, "-1 (%s)\n", sys_errlist[sysErrno]);
		return (1);
	}
	fprintf(outfp, "%d", (int)sysReturn);

	/* insert code to display output arguments here */

	fprintf(outfp, "\n");
	return (1);
}
