/* 
 *  print_getlogin.c -	decode getlogin
 *
 *  <john@lambda.cc.iastate.edu> John Hascall
 *  Wed Nov 12 13:37:26 CST 1997
 *
 */
#include "trace.h"
#include "sysname.h"


/*
 * printargs_getlogin uses these to pass args to
 * printret_getlogin so it can display output args
 */
static long	savArgs[2];		/* XXX: size as needed */
static int	savNumargs;


extern FILE *	outfp;
extern int	max_string;


/* --------------------------- public routines --------------------------- */

/*
 * called on syscall entry
 */
int printargs_getlogin (
	long	sysCallno,
	long *	sysArgs,
	int	sysNumargs,
	char *	sysFormat
) {
	savArgs[0] = sysArgs[0];				/* ptr */
	savArgs[1] = sysArgs[1];				/* len */
	/* XXX: replace this with more specific code */
	printargs_gen(sysCallno, sysArgs, sysNumargs, sysFormat);

	return (1);
}


/*
 * called on syscall exit
 */
int printret_getlogin (
	long	sysCallno,
	long	sysReturn,
	int	sysErrno
) {
	long	len;
	char *	ptr;

	if (sysReturn == -1) {
		fprintf(outfp, "-1 (%s)\n", sys_errlist[sysErrno]);
		return (1);
	}
	fprintf(outfp, "%d", (int)sysReturn);

	/* XXX: insert code to display output arguments here */
	len = (long)savArgs[1];
	ptr = (char *)rd_buf(savArgs[0], len);
	fprintf(outfp, " [");
	pr_string(ptr, len, 1);
	fprintf(outfp, " ]");

	fprintf(outfp, "\n");
	return (1);
}

/* --------------------------- private routines --------------------------- */

