/* 
 *  print_pathconf.c -	Output parameters and return value for pathconf and fpathconf
 *
 *  <tanmaykm@eureka.ad.infosys.com> 
 *  Fri Aug 24 17:56:13 GMT-5 2001
 *
 */
#include "trace.h"
#include "sysname.h"

extern FILE *outfp;
extern int	max_string;

#include <unistd.h>
static void print_pathconf_flag(int name);

/* --------------------------- public routines --------------------------- */

/*
 * called on syscall entry
 */
int printargs_pathconf(long sysCallno, long *sysArgs, int sysNumargs, char *sysFormat) 
{
    fprintf(outfp,"pathconf (");
    p_arg('s',sysArgs[0],255);
    fprintf(outfp,", ");
	print_pathconf_flag((int)sysArgs[1]);
	fprintf(outfp,") = ");

	return (1);
}


/*
 * called on syscall exit
 */
int printret_pathconf(long sysCallno, long sysReturn, int sysErrno) 
{
	if (sysReturn == -1) 
	{
		fprintf(outfp, "-1 (%s)\n", sys_errlist[sysErrno]);
		return (1);
	}
	fprintf(outfp, "%ld\n", (long)sysReturn);
	return (1);
}

/*
 * called on syscall entry
 */
int printargs_fpathconf(long sysCallno, long *sysArgs, int sysNumargs, char *sysFormat) 
{
    fprintf(outfp,"fpathconf (%d, ", (int)sysArgs[0]);
	print_pathconf_flag((int)sysArgs[1]);
	fprintf(outfp,") = ");

	return (1);
}


/*
 * called on syscall exit
 */
int printret_fpathconf(long sysCallno, long sysReturn, int sysErrno) 
{
	if (sysReturn == -1) 
	{
		fprintf(outfp, "-1 (%s)\n", sys_errlist[sysErrno]);
		return (1);
	}
	fprintf(outfp, "%ld\n", (long)sysReturn);
	return (1);
}

/* --------------------------- private routines --------------------------- */

#define PRINTIFDEFINED(x) if(name == x) {fprintf(outfp,"%s%s",iPrinted?" | ":"",#x); iPrinted=1;}
static void print_pathconf_flag(int name)
{
	int iPrinted=0;

#ifdef _PC_FILESIZEBITS
	PRINTIFDEFINED(_PC_FILESIZEBITS)
#endif
#ifdef _PC_LINK_MAX
	PRINTIFDEFINED(_PC_LINK_MAX)
#endif
#ifdef _PC_MAX_CANON
	PRINTIFDEFINED(_PC_MAX_CANON)
#endif
#ifdef _PC_MAX_INPUT
	PRINTIFDEFINED(_PC_MAX_INPUT)
#endif
#ifdef _PC_NAME_MAX
	PRINTIFDEFINED(_PC_NAME_MAX)
#endif
#ifdef _PC_PATH_MAX
	PRINTIFDEFINED(_PC_PATH_MAX)
#endif
#ifdef _PC_PIPE_BUF
	PRINTIFDEFINED(_PC_PIPE_BUF)
#endif
#ifdef _PC_ACL_EXTENDED
	PRINTIFDEFINED(_PC_ACL_EXTENDED)
#endif
#ifdef _PC_CHOWN_RESTRICTED
	PRINTIFDEFINED(_PC_CHOWN_RESTRICTED)
#endif
#ifdef _PC_NO_TRUNC
	PRINTIFDEFINED(_PC_NO_TRUNC)
#endif
#ifdef _PC_VDISABLE
	PRINTIFDEFINED(_PC_VDISABLE)
#endif
	if(!iPrinted) printf("%d", name);
}

