/* 
 *  print_sync2.c -	Print arguments and ret codes of sync2 function. The sunc2 function is used to sync memory buffers to disk
 *
 *  <tanmaykm@eureka.ad.infosys.com> 
 *  Fri Aug 24 18:52:39 GMT-5 2001
 *
 */
#include "trace.h"
#include "sysname.h"

extern FILE *	outfp;
extern int	max_string;

#include <sys/mount.h>

/* --------------------------- public routines --------------------------- */

/*
 * called on syscall entry
 */
int printargs_sync2 (long sysCallno, long *sysArgs, int sysNumargs, char *sysFormat) 
{
	unsigned int iPolicy = (unsigned int)sysArgs[0];
	char *sPolicy = 0;
#ifdef SYNC_SYNCPOLICY
	if(SYNC_SYNCPOLICY == iPolicy) sPolicy = "SYNC_SYNCPOLICY";
#endif
#ifdef SYNC_SMOOTHSYNCPOLICY
	if(SYNC_SMOOTHSYNCPOLICY == iPolicy) sPolicy = "SYNC_SMOOTHSYNCPOLICY";
#endif
	if(sPolicy) fprintf(outfp,"sync2 (%s, ", sPolicy);
	else fprintf(outfp,"sync2 (%d, ", iPolicy);
    p_arg('s',sysArgs[1],255);
    fprintf(outfp,") = ");

	return (1);
}


/*
 * called on syscall exit
 */
int printret_sync2(long sysCallno, long sysReturn, int sysErrno) 
{
	if (sysReturn == -1) 
	{
		fprintf(outfp, "-1 (%s)\n", sys_errlist[sysErrno]);
		return (1);
	}
	fprintf(outfp, "%d\n", (int)sysReturn);
	return (1);
}

/* --------------------------- private routines --------------------------- */

